AppTitle "Epic Fight Game"
Const xmax = 800, ymax = 600
Const xmin = 0, ymin = 0
Graphics xmax,ymax,32,2
SeedRnd MilliSecs()
SetBuffer BackBuffer()

.Start

Include "vars.bb"

load_einstellung("einstellungen.save")

ClsColor 126,28,255
Repeat
	Cls
	
	DrawImage bg,0,0
		
	If KeyHit(200) Then menu = menu - 1
	If KeyHit(208) Then menu = menu + 1
	
	If menu = 0 Then menu = 4
	If menu = 5 Then menu = 1
		
	If KeyHit(28)
		If menu = 1 Then 
			spiel(1)
			Goto Start
		ElseIf menu = 2 Then 
			einstellungen()
		ElseIf menu = 3 Then 
			Text 0,0,"Fehler"
		ElseIf menu = 4 Then
			End
		EndIf
	EndIf
		
	Color 255,255,255
	If menu = 1 Then Text 100,150,"->Spielen!" Else Text 100,150,"Spielen!"
	If menu = 2 Then Text 100,200,"->Einstellungen" Else Text 100,200,"Einstellungen"
	If menu = 3 Then Text 100,250,"->Hilfe" Else Text 100,250,"Hilfe"
	If menu = 4 Then Text 100,300,"->Beenden" Else Text 100,300,"Beenden"	

	
	Flip
Forever

End


Function spiel(map)

ClsColor 105,190,193
Repeat
	Cls
	
	For i = 1 To 1
		If map = i Then
			DrawImage bg_spiel(i),0,0
		EndIf
	Next

	WaitTimer frametimer

	If JoyType(0) = 2 Then
		y# = JoyY(0)
		x# = JoyX(0)
		;hat = JoyHat(0)
		
		If hat = 0 Then player_schussrichtung = NORD
		If hat = 90 Then player_schussrichtung = OST
		If hat = 180 Then player_schussrichtung = SUED
		If hat = 270 Then player_schussrichtung = WEST
		
		If JoyHit(12,0) Then Exit
		
		WechselY = player_y
		player_y = player_y + y * 15
		WechselX = player_x
		player_x = player_x + x * 15
		
		If y > 0.1 Then
			player_richtung = SUED
		ElseIf y < -0.1 Then
			player_richtung = NORD
		ElseIf x > 0.1 Then
			player_richtung = OST
		ElseIf x < -0.1 Then
			player_richtung = WEST
		EndIf
		
		If WechselY <> player_y Or WechselX <> player_x Then	
			player_counter = player_counter + 1
			If player_counter > 3 Then player_counter = 0
			If player_richtung = NORD Then
				DrawImage player_hinten_laufen,player_x,player_y,player_counter
			ElseIf player_richtung = OST Then
				DrawImage player_rechts_laufen,player_x,player_y,player_counter
			ElseIf player_richtung = SUED Then
				DrawImage player_vorne_laufen,player_x,player_y,player_counter
			ElseIf player_richtung = WEST Then
				DrawImage player_links_laufen,player_x,player_y,player_counter
			EndIf
		Else
			player_counter = 0
			If player_richtung = NORD Then
				DrawImage player_hinten_stehen,player_x,player_y,player_counter
			ElseIf player_richtung = OST Then
				DrawImage player_rechts_stehen,player_x,player_y,player_counter
			ElseIf player_richtung = SUED Then
				DrawImage player_vorne_stehen,player_x,player_y,player_counter
			ElseIf player_richtung = WEST Then
				DrawImage player_links_stehen,player_x,player_y,player_counter
			EndIf
		EndIf
		
		If JoyHit(3,0) Then
			player_schutz = player_schutz + 1
			If player_schutz = 2 Then player_schutz = 1
		EndIf
		
		If JoyDown(1,0) Then
			feuerrate = feuerrate + 1
		EndIf
		
	Else
	
		player_counter = player_counter + 1
		If player_counter > 3 Then player_counter = 0
		
		If KeyDown(200) Then
			player_richtung = NORD
			player_schussrichtung = NORD
			player_y = player_y - 15
			DrawImage player_hinten_laufen,player_x,player_y,player_counter
		ElseIf KeyDown(208) Then
			player_richtung = SUED
			player_schussrichtung = SUED
			player_y = player_y + 15
			DrawImage player_vorne_laufen,player_x,player_y,player_counter
		ElseIf KeyDown(203) Then
			player_richtung = WEST
			player_schussrichtung = WEST
			player_x = player_x - 15
			DrawImage player_links_laufen,player_x,player_y,player_counter
		ElseIf KeyDown(205) Then
			player_richtung = OST
			player_schussrichtung = OST
			player_x = player_x + 15
			DrawImage player_rechts_laufen,player_x,player_y,player_counter
		Else
			player_counter = 0
			Select player_richtung
				Case NORD: DrawImage player_hinten_stehen,player_x,player_y,player_counter
				Case OST: DrawImage player_rechts_stehen,player_x,player_y,player_counter
				Case SUED: DrawImage player_vorne_stehen,player_x,player_y,player_counter
				Case WEST: DrawImage player_links_stehen,player_x,player_y,player_counter
			End Select
		EndIf
		
		If KeyHit(28) Then
			player_schutz = player_schutz + 1
			If player_schutz = 2 Then player_schutz = 1
		EndIf
		
		If KeyDown(157) Then
			feuerrate = feuerrate + 1
		EndIf
		
	EndIf	
	
	
	
	If player_schutz = 1 Then
		player_schutz_time = player_schutz_time + 1
		If player_schutz_time = 100 Then
			player_schutz = 3
		EndIf
		DrawImage schutz,player_x,player_y
	EndIf
	
	
	
	If feuerrate = player_feuerrate Then
		shot.TShot = New TShot
		If player_schussrichtung = NORD Then
			shot\X = player_x
			shot\Y = player_y - 16 - 5
			shot\Richtung = NORD
		ElseIf player_schussrichtung = OST Then
			shot\X = player_x + 8 + 5
			shot\Y = player_y
			shot\Richtung = OST
		ElseIf player_schussrichtung = SUED Then
			shot\X = player_x
			shot\Y = player_y + 16 + 5
			shot\Richtung = SUED
		ElseIf player_schussrichtung = WEST Then
			shot\X = player_x - 8 - 5
			shot\Y = player_y
			shot\Richtung = WEST
		EndIf
		feuerrate = 0
	EndIf
	
	If player_x > xmax Then player_x = xmin
	If player_x < xmin Then player_x = xmax
	If player_y > ymax Then player_y = ymin
	If player_y < ymin Then player_y = ymax
	
	If JoyType(1) = 2 Then
		y2# = JoyY(1)
		x2# = JoyX(1)
		
		If JoyHit(7,1) Then Exit
		
		Wechsel2Y = player2_y
		player2_y = player2_y + y2 * 15
		Wechsel2X = player2_x
		player2_x = player2_x + x2 * 15
		
		If y2 > 0.1 Then
			player2_richtung = SUED
		ElseIf y2 < -0.1 Then
			player2_richtung = NORD 
		ElseIf x2 > 0.1 Then
			player2_richtung = OST
		ElseIf x2 < -0.1 Then
			player2_richtung = WEST
		EndIf
		
		If Wechsel2Y <> player2_y Or Wechsel2X <> player2_x Then	
			player2_counter = player2_counter + 1
			If player2_counter > 3 Then player2_counter = 0
			If player2_richtung = NORD Then
				DrawImage player_hinten_laufen,player2_x,player2_y,player2_counter
			ElseIf player2_richtung = OST Then
				DrawImage player_rechts_laufen,player2_x,player2_y,player2_counter
			ElseIf player2_richtung = SUED Then
				DrawImage player_vorne_laufen,player2_x,player2_y,player2_counter
			ElseIf player2_richtung = WEST Then
				DrawImage player_links_laufen,player2_x,player2_y,player2_counter
			EndIf
		Else
			player2_counter = 0
			If player2_richtung = NORD Then
				DrawImage player_hinten_stehen,player2_x,player2_y,player2_counter
			ElseIf player2_richtung = OST Then
				DrawImage player_rechts_stehen,player2_x,player2_y,player2_counter
			ElseIf player2_richtung = SUED Then
				DrawImage player_vorne_stehen,player2_x,player2_y,player2_counter
			ElseIf player2_richtung = WEST Then
				DrawImage player_links_stehen,player2_x,player2_y,player2_counter
			EndIf
		EndIf
		
		If JoyHit(3,1) Then
			player2_schutz = player2_schutz + 1
			If player2_schutz = 2 Then player2_schutz = 1
		EndIf
		
		If JoyDown(1,1) Then
			feuerrate2 = feuerrate2 + 1
		EndIf
		
	Else
	
		player2_counter = player2_counter + 1
		If player2_counter > 3 Then player2_counter = 0
		
		If KeyDown(17) Then
			player2_richtung = NORD
			player2_schussrichtung = NORD
			player2_y = player2_y - 15
			DrawImage player_hinten_laufen,player2_x,player2_y,player2_counter
		ElseIf KeyDown(31) Then
			player2_richtung = SUED
			player2_schussrichtung = SUED
			player2_y = player2_y + 15
			DrawImage player_vorne_laufen,player2_x,player2_y,player2_counter
		ElseIf KeyDown(30) Then
			player2_richtung = WEST
			player2_schussrichtung = WEST
			player2_x = player2_x - 15
			DrawImage player_links_laufen,player2_x,player2_y,player2_counter
		ElseIf KeyDown(32) Then
			player2_richtung = OST
			player2_schussrichtung = OST
			player2_x = player2_x + 15
			DrawImage player_rechts_laufen,player2_x,player2_y,player2_counter
		Else
			player2_counter = 0
			Select player2_richtung
				Case NORD: DrawImage player_hinten_stehen,player2_x,player2_y,player2_counter
				Case OST: DrawImage player_rechts_stehen,player2_x,player2_y,player2_counter
				Case SUED: DrawImage player_vorne_stehen,player2_x,player2_y,player2_counter
				Case WEST: DrawImage player_links_stehen,player2_x,player2_y,player_counter
			End Select
		EndIf
		
		If MouseHit(1) Then
			player2_schutz = player2_schutz + 1
			If player2_schutz = 2 Then player2_schutz = 1
		EndIf
		
		If KeyDown(57) Then
			feuerrate2 = feuerrate2 + 1
		EndIf
	
	EndIf	
	
	If player2_schutz =1 Then
		player2_schutz_time = player2_schutz_time + 1
		If player2_schutz_time = 100 Then
			player2_schutz = 3
		EndIf
		DrawImage schutz,player2_x,player2_y
	EndIf
	
	If feuerrate2 = player2_feuerrate Then
		shot.TShot = New TShot
		If player2_richtung = NORD Then
			shot\X = player2_x
			shot\Y = player2_y - 16 - 5
			shot\Richtung = NORD
		ElseIf player2_richtung = OST Then
			shot\X = player2_x + 8 + 5
			shot\Y = player2_y
			shot\Richtung = OST
		ElseIf player2_richtung = SUED Then
			shot\X = player2_x
			shot\Y = player2_y + 16 + 5
			shot\Richtung = SUED
		ElseIf player2_richtung = WEST Then
			shot\X = player2_x - 8 - 5
			shot\Y = player2_y
			shot\Richtung = WEST
		EndIf
		feuerrate2 = 0
	EndIf
	
	For o.TShot = Each TShot
		If o\Richtung = NORD Then
			o\Y = o\Y - 20
		ElseIf o\Richtung = OST Then 
			o\X = o\X + 20
		ElseIf o\Richtung = SUED Then
			o\Y = o\Y + 20
		ElseIf o\Richtung = WEST Then
			o\X = o\X - 20
		EndIf
		
		DrawImage kugel,o\X,o\Y
		
		If o\X > xmax Or o\X < xmin Or o\Y > ymax Or o\Y < ymin Then 
			Delete o.TShot
			weg = 1
		EndIf
		
		If weg = 0 Then
			If ImagesOverlap(player_vorne_laufen,player_x,player_y,kugel,o\X,o\Y) Then 
				If Not player_schutz = 1 Then
					player_leben = player_leben - 1
				EndIf
				Delete o.TShot
			ElseIf ImagesOverlap(player_vorne_laufen,player2_x,player2_y,kugel,o\X,o\Y)
				If Not player2_schutz = 1 Then
					player2_leben = player2_leben - 1
				EndIf
				Delete o.TShot
			EndIf
		EndIf
		
		If player_leben = 0 Then
			GameOver(2)
			Goto start
		ElseIf player2_leben = 0 Then
			GameOver(1)
			Goto start
		EndIf
		
		If weg = 1 Then weg = 0
		
			
	Next
	
	If player2_x > xmax-16 Then player2_x = xmin+16
	If player2_x < xmin+16 Then player2_x = xmax-16
	If player2_y > ymax-16 Then player2_y = ymin+16
	If player2_y < ymin+16 Then player2_y = ymax-16
	
	Color 0,0,255
	Rect player_x-50,player_y-30,player_leben*10,10
	Color 10,0,255
	Rect player_x-50,player_y-30,100,10,0
	Color 0,255,0
	Rect player2_x-50,player2_y-30,player2_leben*10,10
	Color 10,255,0
	Rect player2_x-50,player2_y-30,100,10,0

	Flip
Until KeyHit(1)

.Start
For q.TShot = Each TShot
	Delete q.TShot
Next

End Function

Function GameOver(winner)
FlushJoy
SetFont font2
	Repeat
		
		Color 0,0,255
		Rect 10,10,player_leben*10,10
		Color 10,0,255
		Rect 10,10,100,10,0
		Color 0,255,0
		Rect xmax-110,10,player2_leben*10,10
		Color 10,255,0
		Rect xmax-110,10,100,10,0
		
		Color 255,255,255
		Text xmax/2,ymax/2,"Gewonnen hat Spieler "+ winner + "!!!",1,1
		
		If JoyHit(2,0) Then Exit
		If JoyHit(2,1) Then Exit
		
		Flip
	Forever
	For g.TShot = Each TShot
		Delete g.TShot
	Next
	FlushKeys
	FlushJoy
End Function

Function einstellungen()

Repeat
	Cls
	
	If KeyHit(200) Then einstell_menu = einstell_menu - 1
	If KeyHit(208) Then einstell_menu = einstell_menu + 1
	
	If einstell_menu < 1 Then einstell_menu = 2
	If einstell_menu > 2 Then einstell_menu = 1
	
	If einstell_menu = 1 Then
		Color 255,0,0
		Rect 20,35,100,10
		If KeyHit(203) Then player_feuerrate = player_feuerrate - 1
		If KeyHit(205) Then player_feuerrate = player_feuerrate + 1
		If player_feuerrate < 1 Then player_feuerrate = 1
		If player_feuerrate > 10 Then player_feuerrate = 10
	ElseIf einstell_menu = 2 Then
		Color 255,0,0
		Rect 20,55,100,10
		If KeyHit(203) Then player2_feuerrate = player2_feuerrate - 1
		If KeyHit(205) Then player2_feuerrate = player2_feuerrate + 1
		If player2_feuerrate < 1 Then player2_feuerrate = 1
		If player2_feuerrate > 10 Then player2_feuerrate = 10
	EndIf
	
	Color 255,255,255
	Text 10,10,"Feuerrate:"
	Text 20,30,"Spieler 1: " + player_feuerrate
	Text 20,50,"Spieler 2: " + player2_feuerrate
		
	Flip
Until KeyHit(1)

save_einstellung("einstellungen.save")

FlushKeys
End Function 


Function save_einstellung(pfad$)

datei$ = WriteFile(pfad$)
WriteInt datei,player_feuerrate
WriteInt datei,player2_feuerrate
CloseFile(datei)

End Function 

Function load_einstellung(pfad$)

	datei = ReadFile(pfad$)
	
	If datei = 0 Then Return 0
	
	player_feuerrate = ReadInt(datei)
	player2_feuerrate = ReadInt(datei)
	
	CloseFile(datei)

End Function 